﻿using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Windows.Forms;
using Pleiades;

namespace LissajousFigure
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Paint(object sender, PaintEventArgs e)
		{
			int sw = 1;

			switch (sw)
			{
				case 1:
					PlotMain(this.CreateGraphics(), this.ClientSize);
					break;
				case 2:
					DoPrint(true);
					this.Close();
					break;
				case 3:
					Bitmap img = new Bitmap(1000, 1000);
					PlotMain(Graphics.FromImage(img), img.Size);
					img.Save(@"test.bmp", System.Drawing.Imaging.ImageFormat.Bmp);
					img.Dispose();
					this.Close();
					break;
			}
		}

		public void PlotMain(Graphics g, Size s)
		{
			Pleiades.GraphLibrary gl = new Pleiades.GraphLibrary();

			gl.PlotBEGIN(g, s);

			gl.AxisInitialize(-1.5, -1.5, 1.5, 1.5);
			gl.Clear();

			gl.AxisX(-1.0, 1.0, 0.1);
			gl.AxisY(-1.0, 1.0, 0.1);

			Plot_Lissajous(gl);

			gl.PlotEND();
		}

		// リサージュ図形
		private void Plot_Lissajous(GraphLibrary gl)
		{
			double deg2rad = Math.PI / 180.0;

			gl.SetPenColor(Color.Red);
			gl.SetPenWidth(3);

			gl.PenUp();
			for (int i = 0; i <= 360; i++)
			{
				if (i != 0)
					gl.PenDown();
				double x = Math.Sin(5 * i * deg2rad + 135 * deg2rad);
				double y = Math.Sin(6 * i * deg2rad);
				gl.Move(x, y);
			}
		}

		private Size paparSize;
		private void DoPrint(bool mode)
		{
			PrintDocument pd = new System.Drawing.Printing.PrintDocument();

			var area = pd.DefaultPageSettings.PrintableArea;
			if (mode == true)
			{   // Landscape
				pd.DefaultPageSettings.Landscape = true;
				paparSize = new Size((int)area.Height, (int)area.Width);
			}
			else
			{   // Portrate
				pd.DefaultPageSettings.Landscape = false;
				paparSize = new Size((int)area.Width, (int)area.Height);
			}
			pd.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(Pd_PrintPage);
			pd.Print();
		}

		private void Pd_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			PlotMain(e.Graphics, paparSize);
		}
	}
}
