﻿Imports System
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Windows.Forms
Imports Pleiades

Namespace LissajousFigure
	Partial Public Class Form1
		Inherits Form

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Form1_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles Me.Paint
			Dim sw As Integer = 1

			Select Case sw
				Case 1
					PlotMain(Me.CreateGraphics(), Me.ClientSize)
				Case 2
					DoPrint(True)
					Me.Close()
				Case 3
					Dim img As New Bitmap(1000, 1000)
					PlotMain(Graphics.FromImage(img), img.Size)
					img.Save("test.bmp", System.Drawing.Imaging.ImageFormat.Bmp)
					img.Dispose()
					Me.Close()
			End Select
		End Sub

		Public Sub PlotMain(ByVal g As Graphics, ByVal s As Size)
			Dim gl As New Pleiades.GraphLibrary()

			gl.PlotBEGIN(g, s)

            gl.AxisInitialize(-1.5, -1.5, 1.5, 1.5)
            gl.Clear()

            gl.AxisX(-1.0, 1.0, 0.1)
			gl.AxisY(-1.0, 1.0, 0.1)

            Plot_Lissajous(gl)

            gl.PlotEND()
        End Sub

        ' リサージュ図形
        Private Sub Plot_Lissajous(ByVal gl As GraphLibrary)
            Dim deg2rad As Double = Math.PI / 180.0

            gl.SetPenColor(Color.Red)
            gl.SetPenWidth(3)

            gl.PenUp()
            For i As Integer = 0 To 360
                If i <> 0 Then
                    gl.PenDown()
                End If
                Dim x As Double = Math.Sin(5 * i * deg2rad + 135 * deg2rad)
                Dim y As Double = Math.Sin(6 * i * deg2rad)
                gl.Move(x, y)
            Next i
        End Sub

        Private paparSize As Size
		Private Sub DoPrint(ByVal mode As Boolean)
			Dim pd As PrintDocument = New System.Drawing.Printing.PrintDocument()

			Dim area = pd.DefaultPageSettings.PrintableArea
			If mode = True Then ' Landscape
				pd.DefaultPageSettings.Landscape = True
				paparSize = New Size(CInt(area.Height), CInt(area.Width))
			Else ' Portrate
				pd.DefaultPageSettings.Landscape = False
				paparSize = New Size(CInt(area.Width), CInt(area.Height))
			End If
			AddHandler pd.PrintPage, AddressOf Pd_PrintPage
			pd.Print()
		End Sub

		Private Sub Pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
			PlotMain(e.Graphics, paparSize)
		End Sub
	End Class
End Namespace
